remove kinsis / unused input settings
[distro-setup] / btrbk-run
index 4f4739d954e39d33c423ea59d06e174244893316..5ff83260022c20d1eeec2217ae8392b61653b69d 100755 (executable)
--- a/btrbk-run
+++ b/btrbk-run
@@ -1,4 +1,20 @@
-#!/bin/bash -l
+#!/bin/bash
+# Copyright (C) 2016 Ian Kelling
+
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+
+#     http://www.apache.org/licenses/LICENSE-2.0
+
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+
+# todo: remove old leaf subvols, like keep up to 1 month or something.
 
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
@@ -11,99 +27,164 @@ usage() {
     exit $1
 }
 
+script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
+
+# note q is owned by root:1000
+# note p/m is owned 1000:1000 and chmod 700
+
+
+mountpoints=()
+
+rsync_mountpoint=/q
+
 conf_only=false
 dry_run=false # mostly for testing
+resume_arg=
+rate_limit=no
+verbose=false
 
-temp=$(getopt -l help,long-opt hcnt "$@") || usage 1
+default_args_file=/etc/btrbk-run.conf
+if [[ -s $default_args_file ]]; then
+    set -- $(< $default_args_file) "$@"
+fi
+
+temp=$(getopt -l help cl:m:nprt:vh "$@") || usage 1
 eval set -- "$temp"
 while true; do
     case $1 in
+        # only creates the config file, does not run btrbk
         -c) conf_only=true; shift ;;
+        -l) rate_limit=$2; shift 2 ;;
+        -m) IFS=, mountpoints=($2); unset IFS; shift 2 ;;
         -n) dry_run=true; dry_run_arg=-n; shift ;;
-        -t) IFS=, targets=($2); shift 2 ;;
+        -p) progress_arg="--progress"; shift ;;
+        # btrbk arg: Resume only. Skips snapshot creation.
+        -r) resume_arg=-r; shift ;;
+        # empty is valid for just doing local snapshot. we have default hosts
+        # we will populate
+        -t) IFS=, targets=($2); unset IFS; shift 2 ;;
+        -v) verbose=true; verbose_arg=-v; shift ;;
         -h|--help) usage ;;
         --) shift; break ;;
         *) echo "$0: Internal error!" ; exit 1 ;;
     esac
 done
-read primary <<<"$@"
 
-##### end command line parsing ########
-
-sed="sed -r --follow-symlinks"
-last_snaps=()
+if [[ -s $default_args_file ]]; then
+    echo "$0: warning: default btrbk-run options set in $default_args_file (sleeping 5 seconds):"
+    cat $default_args_file
+    sleep 5
+fi
 
-target-section() {
-    local root=$1
-    local subvol=$2
-    mountpoint $root &>/dev/null || return
-    cat >>/etc/btrbk.conf <<EOF
-volume $root
-subvolume $subvol
-$remote_target
+echo -e "$0: options: conf_only=$conf_only\ndry_run=$dry_run\nresume_arg=$resume_arg\nrate_limit=$rate_limit\nverbose=$verbose"
 
-EOF
-}
+# set default targets
+if [[ ! -v targets ]]; then
+    case $HOSTNAME in
+        x2|fz)
+            if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+                targets=($HOME_DOMAIN)
+            fi
+            ;;
+        tp)
+            targets=(frodo)
+            if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+                if timeout -s 9 10 ssh x2 :; then
+                    targets+=(x2)
+                fi
+            fi
+            ;;
+        frodo)
+            targets=()
+            ;;
+        *)
+            echo "$0: error: no default targets for this host, use -t"
+            exit 1
+            ;;
+    esac
+fi
 
-rsync-dirs() {
-    local host=$1
-    local path=$2
-    rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
-}
+echo "targets: ${targets[*]}"
 
-last-snap() {
-    vol=${1##*/}
-    cd /mnt/root
-    last_snap=$(
-        for f in $vol.20*; do
-            printf "%s %s\n" $(date -d $(sed -r  's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<${f#$vol.}) +%s) $f
-        done | sort -r | head -n 1 | awk '{print $2}'
-             )
-    last_snaps+=($last_snap)
-}
 
-# note q is owned by root:1000
-# note p is owned 1000:1000 and chmod 700
-mountpoints=(/q)
-if mountpoint /p; then
-    mountpoints+=(/p)
-fi
 
-if [[ ! $targets ]]; then
+if (( ${#mountpoints[@]} )); then
+    for mp in ${mountpoints[@]}; do
+        if [[ -e /nocow/btrfs-stale/$mp ]]; then
+            echo "$0: warning: $mp stale. Sleeping for 3 seconds in case you want to cancel."
+            sleep 3
+        fi
+    done
+else # set default mountpoints
     case $HOSTNAME in
-        tp|x2)
-            if ! timeout -s 9 10 ssh frodo :; then
-                targets=($HOME_DOMAIN)
+        frodo)
+            prospective_mps=(/i)
+            ;;
+        *)
+            prospective_mps=(/a /q)
+            if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+                prospective_mps+=(/o)
             fi
             ;;
     esac
-    targets=(frodo)
+    case ${targets[0]} in
+        kw|kww)
+            prospective_mps=(/a)
+            ;;
+    esac
+
+    for mp in ${prospective_mps[@]}; do # default mountpoints to sync
+        if [[ -e /nocow/btrfs-stale/$mp ]]; then
+            echo "$0: warning: $mp stale, not adding to default mountpoints"
+            continue
+        fi
+        if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
+            mountpoints+=($mp)
+        fi
+    done
 fi
 
+echo "mountpoints: ${mountpoints[*]}"
 
-# umount first to ensure we don't have any errors
-# todo: do some kill fuser stuff to make umount more reliable
-# todo: setup sync systemd timer on $primary, once per hour.
-# todo: setup lock so that if this is already running, we exit out, so
-# that manual runs don't interfere with cronjobs.
-if [[ $primary ]] && ! $dry_run; then
-    for m in ${mountpoints[@]}; do
-        # note, this won't work for /i, due to path being /mnt/iroot
-        # todo: include /i for treetowl/frodo
-        btrfs property set -ts /mnt/root$m ro true
-        ssh root@$primary bash <<EOF
-set -ex
-umount $m
-[[ -e /mnt/root$m ]] || exit 0
-btrfs sub del /mnt/root$m
+##### end command line parsing ########
+
+rsync-dirs() {
+    local host=$1
+    local path=$2
+    m rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
+}
+
+vol-conf() {
+    cat >>/etc/btrbk.conf <<EOF
+volume $vol
 EOF
-    done
+}
+sub-conf() {
+    cat >>/etc/btrbk.conf <<EOF
+subvolume $sub
+EOF
+}
+tg-conf() {
+    cat >>/etc/btrbk.conf <<EOF
+target send-receive ssh://$tg$vol/btrbk
+EOF
+}
+m() { printf "%s: %s\n" "${0##*/}" "$*";  "$@"; }
+
+
+if ! which btrbk &>/dev/null; then
+    echo "$0: error: no btrbk binary found"
 fi
 
-for tg in ${targets[@]}; do
-    cat >/etc/btrbk.conf <<'EOF'
-ssh_identity /root/.ssh/id_rsa
-transaction_syslog daemon
+cat >/etc/btrbk.conf <<EOF
+ssh_identity /root/.ssh/home
+# Just a guess that local7 is a good facility to pick.
+# It's a bit odd that the transaction log has to be logged to
+# a file or syslog, while other output is sent to std out.
+# The man does not mention a way for them to be together, but
+# I dunno if setting a log level like warn might also output
+# transaction info.
+transaction_syslog local7
 
 # so we only run one at a time
 lockfile                   /var/lock/btrbk.lock
@@ -113,48 +194,81 @@ timestamp_format long-iso
 
 # only make a snapshot if things have changed
 snapshot_create onchange
-# much less snapshots because I have less space on the
-# local filesystem.
-snapshot_preserve 2h 2d
+# I could make this different from target_preserve,
+# if one disk had less space.
+# for now, keeping them equal.
+snapshot_preserve 36h 14d 8w 24m
+snapshot_preserve_min 4h
+snapshot_dir btrbk
 
 # so, total backups = ~89
-target_preserve 48h 14d 8w 24m
-target_preserve_min 6h
+target_preserve 36h 14d 8w 24m
+target_preserve_min 4h
 
 # if something fails and it's not obvious, try doing
 # btrbk -l debug -v dryrun
+
+rate_limit $rate_limit
 EOF
 
-    remote_target="target send-receive ssh://${tg}/mnt/root"
 
-    if [[ $tg == frodo && $HOSTNAME == treetowl ]]; then
-        target-section /mnt/iroot i
+# if our mountpoints are from stale snapshots,
+# it doesn't make sense to do a backup.
+check-subvol-stale ${mountpoints[@]} || exit 1
+
+for tg in ${targets[@]}; do
+    # for an initial run, btrbk requires the dir to exist
+    ssh root@$tg mkdir -p /mnt/root/btrbk
+done
+
+
+for m in ${mountpoints[@]}; do
+    # for /i, some special cases. there is just one static target and direction.
+    if [[ $m == /i ]]; then
+        vol=/mnt/iroot
+        vol-conf
+        sub=i
+        sub-conf
+        tg=frodo
+        vol=/mnt/root
+        tg-conf
+    else
+        vol=/mnt/root
+        vol-conf
+        sub=${m##*/}
+        sub-conf
+        for tg in ${targets[@]}; do
+            tg-conf
+        done
     fi
-    for m in ${mountpoints[@]}; do
-        target-section /mnt/root ${m##*/}
-    done
 done
 
+
+# todo: umount first to ensure we don't have any errors
+# todo: do some kill fuser stuff to make umount more reliable
+
+
 if $conf_only; then
     exit
 fi
 
 if $dry_run; then
-    btrbk -n run
+    m btrbk -v -n $resume_arg run
 else
-    btrbk -q run
+    # -q and just using the syslog option seemed nice,
+    # but it doesn't show when a send has a parent and when it doesn't.
+    m btrbk $verbose_arg $progress_arg $resume_arg run
 fi
 
-# if we have /p, rsync to targets without /p
-if mountpoint /p; then
+# if we have it, sync to systems which don't
+if mountpoint $rsync_mountpoint >/dev/null; then
     for tg in ${targets[@]}; do
         case $tg in
             tp|li|lk)
-                # todo, test this
                 for x in /p/c/machine_specific/*.hosts; do
                     if grep -qxF $tg $x; then
                         dir=${x%.hosts}
-                        rsync-dirs ${dir##*/} $dir
+                        rsync-dirs $tg $dir
                     fi
                 done
                 ;;
@@ -162,36 +276,13 @@ if mountpoint /p; then
     done
 fi
 
-first_root=$(awk '$2 == "/mnt/root" {print $1}' /etc/mtab)
+if ! $dry_run; then
+    m $script_dir/mount-latest-remote ${targets[@]}
+fi
 
-# make $primary have the rw snapshot
-if [[ $primary ]] && ! $dry_run; then
-    fstab=()
-    for m in ${mountpoints[@]}; do
-        last-snap $m
-        fstab+=("$first_root  $m  btrfs  noatime,subvol=$last_snap  0 0")
-    done
 
-    printf "%s\n" "${fstab[@]}" | cedit /etc/fstab
-    for d in ${mountpoints[@]}; do
-        mount $d
-        btrfs sub del /mnt/root$d
-    done
-    ssh root@primary bash -s "${mountpoints[*]}" "${last_snaps[*]}" <<'EOF'
-set -xe
-mountpoints=($1)
-last_snaps=($2)
-first_root=$(awk '$2 == "/mnt/root" {print $1}' /etc/mtab)
-for ((i=0; i < ${#mountpoints[@]}; i++)); do
-  m=${mountpoints[i]}
-  vol=${m##*/}
-  fstab+=("$first_root $m  btrfs  noatime,subvol=$vol  0 0")
-  cd /mnt/root
-  btrfs sub snapshot ${last_snaps[i]} $vol
-  mount $m
-done
-EOF
-fi
+# todo: move variable data we don't care about backing up
+# to /nocow and symlink it.
 
 
 # background on btrbk timezones. with short/long, timestamps use local time.
@@ -208,3 +299,5 @@ fi
 # However, in the short term, there will be no inconsistencies.
 # I don't see any problem with shifting when the day starts for
 # retention, so I'm using long-iso.
+
+# note to create a long-iso timestamp: date +%Y%m%dT%H%M%S%z